// CCountdownDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PCWatchDOg.h"
#include "CApplicationException.h"

#include "CCountdownDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCountdownDlg dialog


CCountdownDlg::CCountdownDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCountdownDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCountdownDlg)
	m_sTimeLeft = _T("");
	//}}AFX_DATA_INIT
	m_bCountdownStopped = TRUE;

	// In PCWatchDOgDlg initialized
	// m_iCountdownCounter;
}


void CCountdownDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCountdownDlg)
	DDX_Text(pDX, IDC_STATIC_SHUTDOWN, m_sTimeLeft);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCountdownDlg, CDialog)
	//{{AFX_MSG_MAP(CCountdownDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CString& CCountdownDlg::GetTimeLeft()
{
	return m_sTimeLeft;
};

void CCountdownDlg::SetTimeLeft(const CString& sTimeLeft)
{
	m_sTimeLeft = sTimeLeft;

	// Update the Dialog
	UpdateData(FALSE);
};

CTime& CCountdownDlg::GetCountdownCounter()
{
	return m_tCountdownCounter;
};

void CCountdownDlg::SetCountdownCounter(const CTime& pCountdownCounter)
{
	m_tCountdownCounter = pCountdownCounter;

	//Format the counter for displaying
	CString sAuxString = "";
	sAuxString.Format("%d:%d:%d", m_tCountdownCounter.GetHour(), m_tCountdownCounter.GetMinute(), m_tCountdownCounter.GetSecond());
	
	// Exchange data
	SetTimeLeft(sAuxString);
};

BOOL CCountdownDlg::IsCountdownStopped()
{
	return m_bCountdownStopped;
};

void CCountdownDlg::CountdownStopped(const BOOL& bCountdownStopped)
{
	m_bCountdownStopped = bCountdownStopped;
};

void CCountdownDlg::SetTimerEvent()
{
	// Start the countdown timer
	UINT_PTR iTimerID = SetTimer(ID_COUNTDOWN_TIMER, 1000, NULL); // one second

	if (iTimerID == 0)
    {
		int TODO_no_hard_text;
		// Abnormal condition, something is wrong.
		CApplicationException* pApplicationEx = new CApplicationException("Unable to obtain timer");
		throw (pApplicationEx);
     }
}

void CCountdownDlg::KillTimerEvent()
{
	if (m_bCountdownStopped == TRUE)
	{
		//If countdown was stopped kill the timer
		if (KillTimer(ID_COUNTDOWN_TIMER) == 0)
		{
			int TODO_no_hard_text;
			// Abnormal condition, something is wrong.
			CApplicationException* pApplicationEx = new CApplicationException("Could not find the specified timer event.");
			throw (pApplicationEx);
		 };
	};
};

/////////////////////////////////////////////////////////////////////////////
// CCountdownDlg message handlers

void CCountdownDlg::OnCancel() 
{
	CountdownStopped(TRUE);
	KillTimerEvent();

	CDialog::OnCancel();
}

void CCountdownDlg::OnTimer(UINT nIDEvent) 
{
	// Wich timer triggered this event?
	// The countdown timer?
	if (nIDEvent == ID_COUNTDOWN_TIMER)
	{
		if (IsCountdownStopped() == FALSE)
		{
			// Decrease the counter
			CTime tCountdownCounter = GetCountdownCounter();
			CTimeSpan tsSeconds(1); // 1 second
			tCountdownCounter = tCountdownCounter - tsSeconds;
			if ((tCountdownCounter.GetMinute() >= 0) && (tCountdownCounter.GetSecond() >= 0))
				SetCountdownCounter(tCountdownCounter);
		};
	}
	
	CDialog::OnTimer(nIDEvent);
}
