// CMainFrame.cpp : implementation file
//

#include "stdafx.h"
#include "SerialPortPJ.h"
#include "PCWatchDOg.h"
#include "PCWatchDOgDlg.h"
#include "PCWatchDogTimer.h"
#include "Mmsystem.h"

#include "CMainFrame.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define WM_TRAYNOTIFY WM_USER + 100

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_POPUP_SETUP, OnPopupSetup)
	ON_COMMAND(ID_POPUP_MINIMISE, OnPopupStatus)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_TRAYNOTIFY, OnTrayNotification)
END_MESSAGE_MAP()

CMainFrame::CMainFrame():
m_pPCWatchDOgDlg(new CPCWatchDOgDlg),
m_pPCWatchDogTimer(new PCWatchDogTimer)
{
	//This reduces the CPU usuage of this program
/*  	TIMECAPS tc;
    timeGetDevCaps(&tc, sizeof(TIMECAPS));
    DWORD resolution = min(max(tc.wPeriodMin, 0), tc.wPeriodMax);
	if(resolution < 100)
		resolution = 100;
    timeBeginPeriod(resolution);  
*/
	m_pPCWatchDOgDlg->Create(IDD_PCWATCHDOG_DIALOG);
	m_pPCWatchDOgDlg->ShowWindow(SW_HIDE);

	Initialize();
}

CMainFrame::~CMainFrame()
{
	delete m_pPCWatchDogTimer;
	m_pPCWatchDogTimer = NULL;

	delete m_pPCWatchDOgDlg;
	m_pPCWatchDOgDlg = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

void CMainFrame::Initialize()
{
	try
	{
		m_pPCWatchDOgDlg->SetPCWatchDogTimer(m_pPCWatchDogTimer);

		m_pPCWatchDOgDlg->Initialize();
		m_pPCWatchDogTimer->Initialize();
	
	}
	catch (CSerialException* ex)	// catch Serial Port Exceptions
	{
		// Report the exception error
		AfxMessageBox(ex->GetErrorMessage());
		ex->Delete();

	}
	catch( CFileException* ex )
	{
		// Report the exception error
		TCHAR   szCause[255];
		ex->GetErrorMessage(szCause, 255);

		AfxMessageBox(szCause);
		ex->Delete();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	CBitmap BitmapTrayIcon;

	BitmapTrayIcon.LoadBitmap(IDB_BITMAP_DOG);
	if (!m_TrayIcon.Create(	this,
							IDR_POPUP_MENU,
							_T("PCWatchDog. Right Click for menu"),
							_T("Right Click for menu"),
							_T("PCWatchDog"),
							10,
							CTrayNotifyIcon::Warning,
							&BitmapTrayIcon,
							WM_TRAYNOTIFY,
							IDR_POPUP_MENU))
	{
		AfxMessageBox(_T("Failed to create tray icon 3"), MB_OK | MB_ICONSTOP);
		return -1;
	}

	//Change the default menu item.
	m_TrayIcon.SetDefaultMenuItem(ID_POPUP_SETUP, FALSE);

	return 0;
}


LRESULT CMainFrame::OnTrayNotification(WPARAM wParam, LPARAM lParam)
{
	//Delegate all the work back to the default implementation in CTrayNotifyIcon.
	m_TrayIcon.OnTrayNotification(wParam, lParam);
	return 0L;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame/CTrayNotifyIcon menu message handlers

void CMainFrame::OnPopupSetup() 
{
	m_pPCWatchDOgDlg->ShowWindow(SW_NORMAL);
}

void CMainFrame::OnPopupStatus() 
{
	AfxMessageBox("The status info such as if the porgrams are responding and if not how long it has been.");
}
