// PCWatchDOgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PCWatchDOg.h"
#include "CIniFileReader.h"
#include "PCWatchDogTimer.h"
#include "CApplicationException.h"

#include "PCWatchDOgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPCWatchDOgDlg dialog

CPCWatchDOgDlg::CPCWatchDOgDlg(CWnd* pParent /*=NULL*/):
CDialog(CPCWatchDOgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPCWatchDOgDlg)
	m_ChkXBT		= FALSE;
	m_ChkXverXface	= FALSE;
	m_ChkTimeServer	= FALSE;
	m_ChkTSG		= FALSE;
	m_EditXBT		= _T("");
	m_EditTS		= _T("");
	m_EditTSG		= _T("");
	m_EditXX		= _T("");
	m_EditComPort	= _T("");
	m_ChkHardware	= FALSE;
	m_ChkSoftware	= FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
//	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// Read Application path of Registry
	string sFilePath = CIniFileReader::GetApplicationPath();
	if (sFilePath.empty())
	{
		// Abnormal condition, something is wrong
		CFileException* pFileEx =
			new CFileException(CFileException::badPath); //All or part of the path is invalid.
		throw (pFileEx);
	};

	// Direct way to get the application title.
	string sFileName = AfxGetAppName();
	string sFileNameExt = sFileName +".ini"; 
	
	// Create .INI file class
	m_pIniFileReader = new CIniFileReader(sFilePath+sFileNameExt);

	m_EditCountdown = m_pIniFileReader->GetValueI( "Configuration", "Countdown", 5 );

	string strComPort = m_pIniFileReader->GetValueS( "Configuration", "ComPort", "" );
	m_EditComPort = strComPort.c_str(); // std::string' to 'CString
}

CPCWatchDOgDlg::~CPCWatchDOgDlg()
{
	delete m_pIniFileReader;
	m_pIniFileReader = NULL;

	//KillTimer(ID_CLOCK_TIMER);
};

void CPCWatchDOgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPCWatchDOgDlg)
	DDX_Check(pDX, IDC_CHECK_XBT, m_ChkXBT);
	DDX_Check(pDX, IDC_CHECK_XverXface, m_ChkXverXface);
	DDX_Check(pDX, IDC_CHECK_TimeServer, m_ChkTimeServer);
	DDX_Check(pDX, IDC_CHECK_TSG, m_ChkTSG);
	DDX_Text(pDX, IDC_EDIT_XBT, m_EditXBT);
	DDX_Text(pDX, IDC_EDIT_TS, m_EditTS);
	DDX_Text(pDX, IDC_EDIT_TSG, m_EditTSG);
	DDX_Text(pDX, IDC_EDIT_XX, m_EditXX);
	DDX_Text(pDX, IDC_EDIT_COMPORT, m_EditComPort);
	DDX_Text(pDX, IDC_EDIT_COUNTDOWN, m_EditCountdown);
	DDX_Check(pDX, IDC_CHECK_HARD, m_ChkHardware);
	DDX_Check(pDX, IDC_CHECK_SOFT, m_ChkSoftware);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPCWatchDOgDlg, CDialog)
	//{{AFX_MSG_MAP(CPCWatchDOgDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_XBT, OnCheckXBT)
	ON_BN_CLICKED(IDC_CHECK_XverXface, OnCheckXverXface)
	ON_BN_CLICKED(IDC_CHECK_TSG, OnCheckTSG)
	ON_BN_CLICKED(IDC_CHECK_TimeServer, OnCheckTimeServer)
	ON_EN_CHANGE(IDC_EDIT_COUNTDOWN, OnChangeEditCountdown)
	ON_BN_CLICKED(IDC_CHECK_HARD, OnCheckHardware)
	ON_WM_CANCELMODE()
	ON_BN_CLICKED(IDC_CHECK_SOFT, OnCheckSoftware)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPCWatchDOgDlg message handlers

PCWatchDogTimer* CPCWatchDOgDlg::GetPCWatchDogTimer()
{
	return m_pPCWatchDogTimer;
};

void CPCWatchDOgDlg::SetPCWatchDogTimer(PCWatchDogTimer* pPCWatchDogTimer)
{
	m_pPCWatchDogTimer = pPCWatchDogTimer;
};

void CPCWatchDOgDlg::UpdateSharedMemoryData()
{
	CString sSharedMemoryDataOfXBT	= "";
	CString sSharedMemoryDataOfTSG	= "";
	CString sSharedMemoryDataOfXX	= "";
	CString sSharedMemoryDataOfTS	= "";

	m_pPCWatchDogTimer->ReadSharedMemorys(	sSharedMemoryDataOfXBT,
											sSharedMemoryDataOfTSG,
											sSharedMemoryDataOfXX,
											sSharedMemoryDataOfTS);
	m_EditXBT	= sSharedMemoryDataOfXBT;
	m_EditXX	= sSharedMemoryDataOfXX;
	m_EditTS	= sSharedMemoryDataOfTS;
	m_EditTSG	= sSharedMemoryDataOfTSG;

	// Update the Dialog
	UpdateData(FALSE);
};

BOOL CPCWatchDOgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	// when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPCWatchDOgDlg::Initialize()
{
	// Exchange data
	m_pPCWatchDogTimer->SetEnabled_XBT(m_ChkXBT);
	m_pPCWatchDogTimer->SetEnabled_TS(m_ChkTimeServer);
	m_pPCWatchDogTimer->SetEnabled_TSG(m_ChkTSG);
	m_pPCWatchDogTimer->SetEnabled_XX(m_ChkXverXface);
	m_pPCWatchDogTimer->SetShutdownHardware(m_ChkHardware);
	m_pPCWatchDogTimer->SetShutdownSoftware(m_ChkSoftware);
	m_pPCWatchDogTimer->SetCountdownMinutes(m_EditCountdown);
	m_pPCWatchDogTimer->SetComPort(m_EditComPort);

	UpdateSharedMemoryData();

	// Wait before the process begin (+/- 5 minutes)
	int iBeginWaitTime = m_pIniFileReader->GetValueI( "Configuration", "BeginWaitTime", 300000 );
	Sleep(iBeginWaitTime);

	// Installs a system timer.
	// A time-out value is specified, and every time a time-out occurs.

	// It triggers every 30 seconds.
	UINT iSignalInterval = m_pIniFileReader->GetValueI( "Configuration", "SignalInterval", 30000 );
	UINT iTimerID = SetTimer(ID_CLOCK_TIMER, iSignalInterval, NULL);
	if (iTimerID == 0)
    {
		int TODO_no_hard_text;
		// Abnormal condition, something is wrong.
		CApplicationException* pApplicationEx = new CApplicationException("Unable to obtain timer");
		throw (pApplicationEx);
     }

	iTimerID = SetTimer(ID_REFRESH_TIMER, 1000, NULL);
	if (iTimerID == 0)
    {
		int TODO_no_hard_text;
		// Abnormal condition, something is wrong.
		CApplicationException* pApplicationEx = new CApplicationException("Unable to obtain timer");
		throw (pApplicationEx);
     }
};

void CPCWatchDOgDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPCWatchDOgDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPCWatchDOgDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPCWatchDOgDlg::OnTimer(UINT nIDEvent) 
{
	// Wich timer triggered this event?
	switch (nIDEvent)
	{
		// The clock timer?
		case ID_CLOCK_TIMER:
			if (m_pPCWatchDogTimer->IsFailed() == TRUE)
			{
				// Still in countdown cycle
				m_pPCWatchDogTimer->RunCountdown();
			}
			else
			{
				// Check memory if all is OK
				m_pPCWatchDogTimer->CheckSharedMemorys();
			};
			break;

		// The diolog refresh timer?
		case ID_REFRESH_TIMER:
			UpdateSharedMemoryData();
			break;
	};

	CDialog::OnTimer(nIDEvent);
}

void CPCWatchDOgDlg::OnCheckXBT() 
{
	// Get the current values from the screen
	UpdateData(TRUE);

	m_pPCWatchDogTimer->SetEnabled_XBT(m_ChkXBT);

	if (m_ChkXBT == TRUE)
	{
		// The user want to read XBT location
		m_pPCWatchDogTimer->ResetSharedMemory(
			m_pPCWatchDogTimer->GetSharedMemoryOfXBT());
		m_pPCWatchDogTimer->SetLastReadingXBT(CTime::GetCurrentTime());
	};

	UpdateSharedMemoryData();
}

void CPCWatchDOgDlg::OnCheckXverXface() 
{
	// Get the current values from the screen
	UpdateData(TRUE);

	m_pPCWatchDogTimer->SetEnabled_XX(m_ChkXverXface);

	if (m_ChkXverXface == TRUE)
	{
		// The user want to read XverXface location
		m_pPCWatchDogTimer->ResetSharedMemory(
			m_pPCWatchDogTimer->GetSharedMemoryOfXX());
		m_pPCWatchDogTimer->SetLastReadingXX(CTime::GetCurrentTime());
	};

	UpdateSharedMemoryData();
}

void CPCWatchDOgDlg::OnCheckTSG() 
{
	// Get the current values from the screen
	UpdateData(TRUE);

	m_pPCWatchDogTimer->SetEnabled_TSG(m_ChkTSG);

	if (m_ChkTSG == TRUE)
	{
		// The user want to read TSG location
		m_pPCWatchDogTimer->ResetSharedMemory(
			m_pPCWatchDogTimer->GetSharedMemoryOfTSG());
		m_pPCWatchDogTimer->SetLastReadingTSG(CTime::GetCurrentTime());
	};

	UpdateSharedMemoryData();
	
}

void CPCWatchDOgDlg::OnCheckTimeServer() 
{
	// Get the current values from the screen
	UpdateData(TRUE);

	m_pPCWatchDogTimer->SetEnabled_TS(m_ChkTimeServer);

	if (m_ChkTimeServer == TRUE)
	{
		// The user want to read Time Server location
		m_pPCWatchDogTimer->ResetSharedMemory(
			m_pPCWatchDogTimer->GetSharedMemoryOfTS());
		m_pPCWatchDogTimer->SetLastReadingTS(CTime::GetCurrentTime());
	};

	UpdateSharedMemoryData();
}

void CPCWatchDOgDlg::OnChangeEditCountdown() 
{ 
	// Get the current values from the screen
	UpdateData(TRUE);

	// The user can select the countdown time.
	// An alarm will also be sounded during this time.
	m_pPCWatchDogTimer->SetCountdownMinutes(m_EditCountdown);
}

void CPCWatchDOgDlg::OnCheckHardware() 
{
	// Get the current values from the screen
	UpdateData(TRUE);

	m_pPCWatchDogTimer->SetShutdownHardware(m_ChkHardware);
}

void CPCWatchDOgDlg::OnCheckSoftware() 
{
	// Get the current values from the screen
	UpdateData(TRUE);

	m_pPCWatchDogTimer->SetShutdownSoftware(m_ChkSoftware);
}
